Index: c/src/ada-tests/mptests/mp01/config.h
===================================================================
--- c/src/ada-tests/mptests/mp01/config.h	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp01/config.h	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -8,5 +8,5 @@
  *  The license and distribution terms for this file may in
  *  the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/ada-tests/mptests/mp01/mp01.adb
===================================================================
--- c/src/ada-tests/mptests/mp01/mp01.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp01/mp01.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -15,5 +15,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp01/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp01/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp01/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp01/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp01/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp01/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp02/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp02/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp02/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp02/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp02/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp02/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp03/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp03/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp03/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp03/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp03/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp03/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp04/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp04/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp04/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp04/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp04/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp04/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp05/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp05/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp05/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp05/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp05/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp05/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp06/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp06/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp06/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp06/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp06/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp06/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp07/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp07/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp07/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp07/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp07/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp07/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp08/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp08/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp08/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp08/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp08/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp08/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp09/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp09/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp09/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp09/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp09/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp09/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp10/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp10/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp10/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp10/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp10/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp10/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp11/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp11/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp11/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp11/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp11/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp11/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp12/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp12/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp12/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp12/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp12/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp12/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp13/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp13/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp13/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp13/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp13/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp13/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp14/mptest.adb
===================================================================
--- c/src/ada-tests/mptests/mp14/mptest.adb	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp14/mptest.adb	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$
Index: c/src/ada-tests/mptests/mp14/mptest.ads
===================================================================
--- c/src/ada-tests/mptests/mp14/mptest.ads	(revision 3c0534a3a097f88e974e77e3195d0604a0ed7b64)
+++ c/src/ada-tests/mptests/mp14/mptest.ads	(revision 35e4691b9a170a729b2908e9dfb67d4477266739)
@@ -16,5 +16,5 @@
 --  The license and distribution terms for this file may in
 --  the file LICENSE in this distribution or at
---  http://www.OARcorp.com/rtems/license.html.
+--  http://www.rtems.com/license/LICENSE.
 --
 --  $Id$