Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 0945123ecde55ede462487f90aec3a227abb4694)
+++ cpukit/ChangeLog	(revision 37b9679238953f3bcb4a6b52814bae2da8e98361)
@@ -1,2 +1,8 @@
+2007-01-16	Till Straumann <strauman@slac.stanford.edu>
+	* libnetworking/rtems/rtems_mii_ioctl.c,
+	* libnetworking/rtems/rtems_mii_ioctl.h,
+	* libnetworking/rtems/rtems_mii_ioctl_kern.c:
+	Added SLAC/Stanford Authorship Note / Copyright + Liability Disclaimer.
+
 2007-01-11	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/libnetworking/rtems/rtems_mii_ioctl.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_mii_ioctl.c	(revision 0945123ecde55ede462487f90aec3a227abb4694)
+++ cpukit/libnetworking/rtems/rtems_mii_ioctl.c	(revision 37b9679238953f3bcb4a6b52814bae2da8e98361)
@@ -9,5 +9,48 @@
  */
 
-/* Author: Till Straumann, <straumanatslacdotstandorddotedu>, 2005 */
+/* 
+ * Authorship
+ * ----------
+ * This software was created by
+ *     Till Straumann <strauman@slac.stanford.edu>, 2005,
+ * 	   Stanford Linear Accelerator Center, Stanford University.
+ * 
+ * Acknowledgement of sponsorship
+ * ------------------------------
+ * This software was produced by
+ *     the Stanford Linear Accelerator Center, Stanford University,
+ * 	   under Contract DE-AC03-76SFO0515 with the Department of Energy.
+ * 
+ * Government disclaimer of liability
+ * ----------------------------------
+ * Neither the United States nor the United States Department of Energy,
+ * nor any of their employees, makes any warranty, express or implied, or
+ * assumes any legal liability or responsibility for the accuracy,
+ * completeness, or usefulness of any data, apparatus, product, or process
+ * disclosed, or represents that its use would not infringe privately owned
+ * rights.
+ * 
+ * Stanford disclaimer of liability
+ * --------------------------------
+ * Stanford University makes no representations or warranties, express or
+ * implied, nor assumes any liability for the use of this software.
+ * 
+ * Stanford disclaimer of copyright
+ * --------------------------------
+ * Stanford University, owner of the copyright, hereby disclaims its
+ * copyright and all other rights in this software.  Hence, anyone may
+ * freely use it for any purpose without restriction.  
+ * 
+ * Maintenance of notices
+ * ----------------------
+ * In the interest of clarity regarding the origin and status of this
+ * SLAC software, this and all the preceding Stanford University notices
+ * are to remain affixed to any copy or derivative of this software made
+ * or distributed by the recipient and are to be affixed to any copy of
+ * software made or distributed by the recipient that contains a copy or
+ * derivative of this software.
+ * 
+ * ------------------ SLAC Software Notices, Set 4 OTT.002a, 2004 FEB 03
+ */ 
 
 #include <rtems.h>
Index: cpukit/libnetworking/rtems/rtems_mii_ioctl.h
===================================================================
--- cpukit/libnetworking/rtems/rtems_mii_ioctl.h	(revision 0945123ecde55ede462487f90aec3a227abb4694)
+++ cpukit/libnetworking/rtems/rtems_mii_ioctl.h	(revision 37b9679238953f3bcb4a6b52814bae2da8e98361)
@@ -4,9 +4,51 @@
  * NOTE: This much simpler than the BSD ifmedia API 
  *
- * Author: Till Straumann, <strauman@slac.stanford.edu>, 2005
- *
  *  $Id$
  */
 
+/* 
+ * Authorship
+ * ----------
+ * This software was created by
+ *     Till Straumann <strauman@slac.stanford.edu>, 2005,
+ * 	   Stanford Linear Accelerator Center, Stanford University.
+ * 
+ * Acknowledgement of sponsorship
+ * ------------------------------
+ * This software was produced by
+ *     the Stanford Linear Accelerator Center, Stanford University,
+ * 	   under Contract DE-AC03-76SFO0515 with the Department of Energy.
+ * 
+ * Government disclaimer of liability
+ * ----------------------------------
+ * Neither the United States nor the United States Department of Energy,
+ * nor any of their employees, makes any warranty, express or implied, or
+ * assumes any legal liability or responsibility for the accuracy,
+ * completeness, or usefulness of any data, apparatus, product, or process
+ * disclosed, or represents that its use would not infringe privately owned
+ * rights.
+ * 
+ * Stanford disclaimer of liability
+ * --------------------------------
+ * Stanford University makes no representations or warranties, express or
+ * implied, nor assumes any liability for the use of this software.
+ * 
+ * Stanford disclaimer of copyright
+ * --------------------------------
+ * Stanford University, owner of the copyright, hereby disclaims its
+ * copyright and all other rights in this software.  Hence, anyone may
+ * freely use it for any purpose without restriction.  
+ * 
+ * Maintenance of notices
+ * ----------------------
+ * In the interest of clarity regarding the origin and status of this
+ * SLAC software, this and all the preceding Stanford University notices
+ * are to remain affixed to any copy or derivative of this software made
+ * or distributed by the recipient and are to be affixed to any copy of
+ * software made or distributed by the recipient that contains a copy or
+ * derivative of this software.
+ * 
+ * ------------------ SLAC Software Notices, Set 4 OTT.002a, 2004 FEB 03
+ */ 
 #ifndef RTEMS_MII_IOCTL_H
 #define RTEMS_MII_IOCTL_H
Index: cpukit/libnetworking/rtems/rtems_mii_ioctl_kern.c
===================================================================
--- cpukit/libnetworking/rtems/rtems_mii_ioctl_kern.c	(revision 0945123ecde55ede462487f90aec3a227abb4694)
+++ cpukit/libnetworking/rtems/rtems_mii_ioctl_kern.c	(revision 37b9679238953f3bcb4a6b52814bae2da8e98361)
@@ -9,5 +9,48 @@
  */
 
-/* Author: Till Straumann, <straumanatslacdotstandorddotedu>, 2005 */
+/* 
+ * Authorship
+ * ----------
+ * This software was created by
+ *     Till Straumann <strauman@slac.stanford.edu>, 2005,
+ * 	   Stanford Linear Accelerator Center, Stanford University.
+ * 
+ * Acknowledgement of sponsorship
+ * ------------------------------
+ * This software was produced by
+ *     the Stanford Linear Accelerator Center, Stanford University,
+ * 	   under Contract DE-AC03-76SFO0515 with the Department of Energy.
+ * 
+ * Government disclaimer of liability
+ * ----------------------------------
+ * Neither the United States nor the United States Department of Energy,
+ * nor any of their employees, makes any warranty, express or implied, or
+ * assumes any legal liability or responsibility for the accuracy,
+ * completeness, or usefulness of any data, apparatus, product, or process
+ * disclosed, or represents that its use would not infringe privately owned
+ * rights.
+ * 
+ * Stanford disclaimer of liability
+ * --------------------------------
+ * Stanford University makes no representations or warranties, express or
+ * implied, nor assumes any liability for the use of this software.
+ * 
+ * Stanford disclaimer of copyright
+ * --------------------------------
+ * Stanford University, owner of the copyright, hereby disclaims its
+ * copyright and all other rights in this software.  Hence, anyone may
+ * freely use it for any purpose without restriction.  
+ * 
+ * Maintenance of notices
+ * ----------------------
+ * In the interest of clarity regarding the origin and status of this
+ * SLAC software, this and all the preceding Stanford University notices
+ * are to remain affixed to any copy or derivative of this software made
+ * or distributed by the recipient and are to be affixed to any copy of
+ * software made or distributed by the recipient that contains a copy or
+ * derivative of this software.
+ * 
+ * ------------------ SLAC Software Notices, Set 4 OTT.002a, 2004 FEB 03
+ */ 
 
 /* include first to avoid 'malloc' clash with rtems_bsdnet_malloc() hack */